# R[h1.6
library(glmnet)
library(MASS)

# p[^̐ݒ
n<- 100
d<- 20
s<- 10

beta<- rep(0, d)
beta[1:s]<- runif(s, -1, 1)

rho<- 0.5
sig<- 2
tmp<- outer(1:d, 1:d, "-")
Sig<- rho^{abs(tmp)}

x<- mvrnorm(n, rep(0, d), Sig)
y<- as.numeric(x%*%beta+rnorm(n, 0, sig))

x<- scale(x)
y<- y - mean(y)

# ʋKɂ郂fI
fit<- glmnet(x, y, family="gaussian", alpha=1)
cp<- (1- fit$dev.ratio) * fit$nulldev / n + 2 * sig^2 / n * fit$df
lambda<- fit$lambda

# ʋK̃vbg
plot(log(lambda), cp, xlab="Log Lambda", ylab="", type="b", pch=16, cex.axis=1.5, cex.lab=1.5)
grid()
abline(v= log(lambda[which(cp==min(cp))]), lty=2, lwd=1.5)
